apeman-service-eventsource
==========

<!---
This file is generated by ape-tmpl. Do not update manually.
--->

<!-- Badge Start -->
<a name="badges"></a>

[![Build Status][bd_travis_shield_url]][bd_travis_url]
[![Code Climate][bd_codeclimate_shield_url]][bd_codeclimate_url]
[![Code Coverage][bd_codeclimate_coverage_shield_url]][bd_codeclimate_url]
[![npm Version][bd_npm_shield_url]][bd_npm_url]
[![JS Standard][bd_standard_shield_url]][bd_standard_url]

[bd_repo_url]: https://github.com/apeman-service-labo/apeman-service-eventsource
[bd_travis_url]: http://travis-ci.org/apeman-service-labo/apeman-service-eventsource
[bd_travis_shield_url]: http://img.shields.io/travis/apeman-service-labo/apeman-service-eventsource.svg?style=flat
[bd_travis_com_url]: http://travis-ci.com/apeman-service-labo/apeman-service-eventsource
[bd_travis_com_shield_url]: https://api.travis-ci.com/apeman-service-labo/apeman-service-eventsource.svg?token=
[bd_license_url]: https://github.com/apeman-service-labo/apeman-service-eventsource/blob/master/LICENSE
[bd_codeclimate_url]: http://codeclimate.com/github/apeman-service-labo/apeman-service-eventsource
[bd_codeclimate_shield_url]: http://img.shields.io/codeclimate/github/apeman-service-labo/apeman-service-eventsource.svg?style=flat
[bd_codeclimate_coverage_shield_url]: http://img.shields.io/codeclimate/coverage/github/apeman-service-labo/apeman-service-eventsource.svg?style=flat
[bd_gemnasium_url]: https://gemnasium.com/apeman-service-labo/apeman-service-eventsource
[bd_gemnasium_shield_url]: https://gemnasium.com/apeman-service-labo/apeman-service-eventsource.svg
[bd_npm_url]: http://www.npmjs.org/package/apeman-service-eventsource
[bd_npm_shield_url]: http://img.shields.io/npm/v/apeman-service-eventsource.svg?style=flat
[bd_standard_url]: http://standardjs.com/
[bd_standard_shield_url]: https://img.shields.io/badge/code%20style-standard-brightgreen.svg

<!-- Badge End -->


<!-- Description Start -->
<a name="description"></a>

Apeman service for SSE event source

<!-- Description End -->


<!-- Overview Start -->
<a name="overview"></a>



<!-- Overview End -->


<!-- Sections Start -->
<a name="sections"></a>

<!-- Section from "doc/guides/01.Installation.md.hbs" Start -->

<a name="section-doc-guides-01-installation-md"></a>

Installation
-----

```bash
$ npm install apeman-service-eventsource --save
```


<!-- Section from "doc/guides/01.Installation.md.hbs" End -->

<!-- Section from "doc/guides/02.Usage.md.hbs" Start -->

<a name="section-doc-guides-02-usage-md"></a>

Usage
---------

```javascript
#!/usr/bin/env node

'use strict'

const { ApEventsourceService } = require('apeman-service-eventsource')
const { createStore } = require('redux')
const { reducer } = require('apeman-service-base')
const co = require('co')

co(function * () {
  let store = createStore(reducer)
  let { observe } = new ApEventsourceService(store)

  let server = observe('/sse/system', {}, {
    'server:restart': (e) => { /* ... */ }
  })

  /* ... */

  server.close()

}).catch((err) => console.error(err))

```


<!-- Section from "doc/guides/02.Usage.md.hbs" End -->

<!-- Section from "doc/guides/03.API.md.hbs" Start -->

<a name="section-doc-guides-03-a-p-i-md"></a>

API
---------

# apeman-service-eventsource@1.0.0

Apeman service for SSE event source

+ Functions
  + [create(args)](#apeman-service-eventsource-function-create)
+ [ApEventsourceService](apeman-service-eventsource-classes) Class
  + [new ApEventsourceService(store, options)](#apeman-service-eventsource-classes-ap-eventsource-service-constructor)
  + [service.observe(url, params, handlers)](#apeman-service-eventsource-classes-ap-eventsource-service-observe)

## Functions

<a class='md-heading-link' name="apeman-service-eventsource-function-create" ></a>

### create(args) -> `ApEventsourceService`

Create the service instance

| Param | Type | Description |
| ----- | --- | -------- |
| args | * |  |



<a class='md-heading-link' name="apeman-service-eventsource-classes"></a>

## ApEventsourceService Class

Service


<a class='md-heading-link' name="apeman-service-eventsource-classes-ap-eventsource-service-constructor" ></a>

### new ApEventsourceService(store, options)

Constructor of ApEventsourceService class

| Param | Type | Description |
| ----- | --- | -------- |
| store | Object | Redux store |
| options | Object | Optional settings |


<a class='md-heading-link' name="apeman-service-eventsource-classes-ap-eventsource-service-observe" ></a>

### service.observe(url, params, handlers) -> `EventSource`

Observe event source

| Param | Type | Description |
| ----- | --- | -------- |
| url | string |  |
| params | Object |  |
| handlers | Object | Event handlers |







<!-- Section from "doc/guides/03.API.md.hbs" End -->


<!-- Sections Start -->


<!-- LICENSE Start -->
<a name="license"></a>

License
-------
This software is released under the [MIT License](https://github.com/apeman-service-labo/apeman-service-eventsource/blob/master/LICENSE).

<!-- LICENSE End -->


<!-- Links Start -->
<a name="links"></a>

Links
------

+ [apeman][apeman_url]

[apeman_url]: https://github.com/apeman-labo/apeman

<!-- Links End -->
